# -*- coding: utf-8 -*-

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
from Murm import murm

#Simulation, Luleå, Tau=0 years
rho=[[1,0.5,0.5],[0.5,1,0.5],[0.5,0.5,1]]
rho_t=0
sim_start=2020
sim_end=2170
tau=0

N=30
seed=93

cost,cost_env,length,age,under,W_dig,W_no_dig,S_dig,S_no_dig,R,R_coord,under_w,under_s,under_r=murm(rho,rho_t,sim_start,sim_end,tau,seed)


for i in range(N):
    print(i)
    seed=seed+1
    new_cost, new_cost_env, new_length, new_age, new_under, new_W_dig, new_W_no_dig, new_S_dig, new_S_no_dig, new_R, new_R_coord, new_under_w, new_under_s, new_under_r=murm(rho,rho_t,sim_start,sim_end,tau,seed)
    cost=np.column_stack((cost,new_cost))
    cost_env=np.column_stack((cost_env,new_cost_env))
    length=np.column_stack((length,new_length))
    age=np.dstack((age,new_age))
    under=np.dstack((under,new_under))
    W_dig=np.column_stack((W_dig,new_W_dig))
    W_no_dig=np.column_stack((W_no_dig,new_W_no_dig))
    S_dig=np.column_stack((S_dig,new_S_dig))
    S_no_dig=np.column_stack((S_no_dig,new_S_no_dig))
    R=np.column_stack((R,new_R))
    R_coord=np.column_stack((R_coord,new_R_coord))
    under_w=np.column_stack((under_w,new_under_w))
    under_s=np.column_stack((under_s,new_under_s))
    under_r=np.column_stack((under_r,new_under_r))


cost_avg=0.0000001*np.average(cost,axis=1)
cost_std=0.0000001*np.std(cost,axis=1)
cost_lower=cost_avg-(2.0/np.sqrt(N+1))*cost_std
cost_upper=cost_avg+(2.0/np.sqrt(N+1))*cost_std

cost_env_avg=0.001*np.average(cost_env,axis=1)
cost_env_std=0.001*np.std(cost_env,axis=1)
cost_env_lower=cost_env_avg-(2.0/np.sqrt(N+1))*cost_env_std
cost_env_upper=cost_env_avg+(2.0/np.sqrt(N+1))*cost_env_std

length_avg=np.average(length,axis=1)
length_std=np.std(length,axis=1)
length_lower=length_avg-(2.0/np.sqrt(N+1))*length_std
length_upper=length_avg+(2.0/np.sqrt(N+1))*length_std


age_avg=np.average(age,axis=2)
age_std=np.std(age,axis=2)
age_lower=age_avg-(2.0/np.sqrt(N+1))*age_std
age_upper=age_avg+(2.0/np.sqrt(N+1))*age_std

under_avg=0.001*np.average(under,axis=2)
under_std=0.001*np.std(under,axis=2)
under_lower=under_avg-(2.0/np.sqrt(N+1))*under_std
under_upper=under_avg+(2.0/np.sqrt(N+1))*under_std

W_dig_avg=100*np.average(W_dig,axis=1)
W_dig_std=100*np.std(W_dig,axis=1)
W_dig_lower=W_dig_avg-(2.0/np.sqrt(N+1))*W_dig_std
W_dig_upper=W_dig_avg+(2.0/np.sqrt(N+1))*W_dig_std

W_no_dig_avg=100*np.average(W_no_dig,axis=1)
W_no_dig_std=100*np.std(W_no_dig,axis=1)
W_no_dig_lower=W_no_dig_avg-(2.0/np.sqrt(N+1))*W_no_dig_std
W_no_dig_upper=W_no_dig_avg+(2.0/np.sqrt(N+1))*W_no_dig_std

S_dig_avg=100*np.average(S_dig,axis=1)
S_dig_std=100*np.std(S_dig,axis=1)
S_dig_lower=S_dig_avg-(2.0/np.sqrt(N+1))*S_dig_std
S_dig_upper=S_dig_avg+(2.0/np.sqrt(N+1))*S_dig_std

S_no_dig_avg=100*np.average(S_no_dig,axis=1)
S_no_dig_std=100*np.std(S_no_dig,axis=1)
S_no_dig_lower=S_no_dig_avg-(2.0/np.sqrt(N+1))*S_no_dig_std
S_no_dig_upper=S_no_dig_avg+(2.0/np.sqrt(N+1))*S_no_dig_std

R_avg=100*np.average(R,axis=1)
R_std=100*np.std(R,axis=1)
R_lower=R_avg-(2.0/np.sqrt(N+1))*R_std
R_upper=R_avg+(2.0/np.sqrt(N+1))*R_std

R_coord_avg=100*np.average(R_coord,axis=1)
R_coord_std=100*np.std(R_coord,axis=1)
R_coord_lower=R_coord_avg-(2.0/np.sqrt(N+1))*R_coord_std
R_coord_upper=R_coord_avg+(2.0/np.sqrt(N+1))*R_coord_std

under_w_avg=100*np.average(under_w,axis=1)
under_w_std=100*np.std(under_w,axis=1)
under_w_lower=under_w_avg-(2.0/np.sqrt(N+1))*under_w_std
under_w_upper=under_w_avg+(2.0/np.sqrt(N+1))*under_w_std

under_s_avg=100*np.average(under_s,axis=1)
under_s_std=100*np.std(under_s,axis=1)
under_s_lower=under_s_avg-(2.0/np.sqrt(N+1))*under_s_std
under_s_upper=under_s_avg+(2.0/np.sqrt(N+1))*under_s_std

under_r_avg=100*np.average(under_r,axis=1)
under_r_std=100*np.std(under_r,axis=1)
under_r_lower=under_r_avg-(2.0/np.sqrt(N+1))*under_r_std
under_r_upper=under_r_avg+(2.0/np.sqrt(N+1))*under_r_std

time_axis=range(sim_start,sim_end)
time_axis_full=range(sim_start,sim_end)

fig, axs = plt.subplots(4, 3)
axs[0, 0].plot(time_axis,cost_avg, '-', color='blue')
axs[0, 0].fill_between(time_axis,cost_lower,cost_upper,color='blue', alpha=0.2)
axs[0, 0].set_title('Capital cost')

axs[0, 1].plot(time_axis,cost_env_avg, '-', color='blue')
axs[0, 1].fill_between(time_axis,cost_env_lower,cost_env_upper,color='blue', alpha=0.2)
axs[0, 1].set_title('Global Warming Potential')

axs[0, 2].plot(time_axis_full,length_avg, '-', color='blue')
axs[0, 2].fill_between(time_axis_full,length_lower,length_upper,color='blue', alpha=0.2)
axs[0, 2].set_title('Excavated volume')

axs[1, 0].plot(time_axis_full,W_dig_avg, '-', color='blue')
axs[1, 0].fill_between(time_axis_full,W_dig_lower,W_dig_upper,color='blue', alpha=0.2)
axs[1, 0].set_title('Renewal rate water - open cut')

axs[2, 0].plot(time_axis_full,W_no_dig_avg, '-', color='blue')
axs[2, 0].fill_between(time_axis_full,W_no_dig_lower,W_no_dig_upper,color='blue', alpha=0.2)
axs[2, 0].set_title('Renewal rate water - trenchless')

axs[1, 1].plot(time_axis_full,S_dig_avg, '-', color='blue')
axs[1, 1].fill_between(time_axis_full,S_dig_lower,S_dig_upper,color='blue', alpha=0.2)
axs[1, 1].set_title('Renewal rate sewer - open cut')

axs[2, 1].plot(time_axis_full,S_no_dig_avg, '-', color='blue')
axs[2, 1].fill_between(time_axis_full,S_no_dig_lower,S_no_dig_upper,color='blue', alpha=0.2)
axs[2, 1].set_title('Renewal rate sewer - trenchless')

axs[1, 2].plot(time_axis_full,R_coord_avg, '-', color='blue')
axs[1, 2].fill_between(time_axis_full,R_coord_lower,R_coord_upper,color='blue', alpha=0.2)
axs[1, 2].set_title('Renewal rate road - coordinated')

axs[2, 2].plot(time_axis_full,R_avg, '-', color='blue')
axs[2, 2].fill_between(time_axis_full,R_lower,R_upper,color='blue', alpha=0.2)
axs[2, 2].set_title('Renewal rate road - alone')

axs[3, 0].plot(time_axis_full,under_w_avg, '-', color='blue')
axs[3, 0].fill_between(time_axis_full,under_w_lower,under_w_upper,color='blue', alpha=0.2)
axs[3, 0].set_title('Mean underutilization ratio - water')

axs[3, 1].plot(time_axis_full,under_s_avg, '-', color='blue')
axs[3, 1].fill_between(time_axis_full,under_s_lower,under_s_upper,color='blue', alpha=0.2)
axs[3, 1].set_title('Mean underutilization ratio - sewer')

axs[3, 2].plot(time_axis_full,under_r_avg, '-', color='blue')
axs[3, 2].fill_between(time_axis_full,under_r_lower,under_r_upper,color='blue', alpha=0.2)
axs[3, 2].set_title('Mean underutilization ratio - road')


#Simulation, Luleå, Tau=20 years
rho=[[1,0.5,0.5],[0.5,1,0.5],[0.5,0.5,1]]
rho_t=0
sim_start=2020
sim_end=2170
tau=20

N=30
seed=93

cost,cost_env,length,age,under,W_dig,W_no_dig,S_dig,S_no_dig,R,R_coord,under_w,under_s,under_r=murm(rho,rho_t,sim_start,sim_end,tau,seed)


for i in range(N):
    print(i)
    seed=seed+1
    new_cost, new_cost_env, new_length, new_age, new_under, new_W_dig, new_W_no_dig, new_S_dig, new_S_no_dig, new_R, new_R_coord, new_under_w, new_under_s, new_under_r=murm(rho,rho_t,sim_start,sim_end,tau,seed)
    cost=np.column_stack((cost,new_cost))
    cost_env=np.column_stack((cost_env,new_cost_env))
    length=np.column_stack((length,new_length))
    age=np.dstack((age,new_age))
    under=np.dstack((under,new_under))
    W_dig=np.column_stack((W_dig,new_W_dig))
    W_no_dig=np.column_stack((W_no_dig,new_W_no_dig))
    S_dig=np.column_stack((S_dig,new_S_dig))
    S_no_dig=np.column_stack((S_no_dig,new_S_no_dig))
    R=np.column_stack((R,new_R))
    R_coord=np.column_stack((R_coord,new_R_coord))
    under_w=np.column_stack((under_w,new_under_w))
    under_s=np.column_stack((under_s,new_under_s))
    under_r=np.column_stack((under_r,new_under_r))


cost_avg=0.0000001*np.average(cost,axis=1)
cost_std=0.0000001*np.std(cost,axis=1)
cost_lower=cost_avg-(2.0/np.sqrt(N+1))*cost_std
cost_upper=cost_avg+(2.0/np.sqrt(N+1))*cost_std

cost_env_avg=0.001*np.average(cost_env,axis=1)
cost_env_std=0.001*np.std(cost_env,axis=1)
cost_env_lower=cost_env_avg-(2.0/np.sqrt(N+1))*cost_env_std
cost_env_upper=cost_env_avg+(2.0/np.sqrt(N+1))*cost_env_std

length_avg=np.average(length,axis=1)
length_std=np.std(length,axis=1)
length_lower=length_avg-(2.0/np.sqrt(N+1))*length_std
length_upper=length_avg+(2.0/np.sqrt(N+1))*length_std


age_avg=np.average(age,axis=2)
age_std=np.std(age,axis=2)
age_lower=age_avg-(2.0/np.sqrt(N+1))*age_std
age_upper=age_avg+(2.0/np.sqrt(N+1))*age_std

under_avg=0.001*np.average(under,axis=2)
under_std=0.001*np.std(under,axis=2)
under_lower=under_avg-(2.0/np.sqrt(N+1))*under_std
under_upper=under_avg+(2.0/np.sqrt(N+1))*under_std

W_dig_avg=100*np.average(W_dig,axis=1)
W_dig_std=100*np.std(W_dig,axis=1)
W_dig_lower=W_dig_avg-(2.0/np.sqrt(N+1))*W_dig_std
W_dig_upper=W_dig_avg+(2.0/np.sqrt(N+1))*W_dig_std

W_no_dig_avg=100*np.average(W_no_dig,axis=1)
W_no_dig_std=100*np.std(W_no_dig,axis=1)
W_no_dig_lower=W_no_dig_avg-(2.0/np.sqrt(N+1))*W_no_dig_std
W_no_dig_upper=W_no_dig_avg+(2.0/np.sqrt(N+1))*W_no_dig_std

S_dig_avg=100*np.average(S_dig,axis=1)
S_dig_std=100*np.std(S_dig,axis=1)
S_dig_lower=S_dig_avg-(2.0/np.sqrt(N+1))*S_dig_std
S_dig_upper=S_dig_avg+(2.0/np.sqrt(N+1))*S_dig_std

S_no_dig_avg=100*np.average(S_no_dig,axis=1)
S_no_dig_std=100*np.std(S_no_dig,axis=1)
S_no_dig_lower=S_no_dig_avg-(2.0/np.sqrt(N+1))*S_no_dig_std
S_no_dig_upper=S_no_dig_avg+(2.0/np.sqrt(N+1))*S_no_dig_std

R_avg=100*np.average(R,axis=1)
R_std=100*np.std(R,axis=1)
R_lower=R_avg-(2.0/np.sqrt(N+1))*R_std
R_upper=R_avg+(2.0/np.sqrt(N+1))*R_std

R_coord_avg=100*np.average(R_coord,axis=1)
R_coord_std=100*np.std(R_coord,axis=1)
R_coord_lower=R_coord_avg-(2.0/np.sqrt(N+1))*R_coord_std
R_coord_upper=R_coord_avg+(2.0/np.sqrt(N+1))*R_coord_std

under_w_avg=100*np.average(under_w,axis=1)
under_w_std=100*np.std(under_w,axis=1)
under_w_lower=under_w_avg-(2.0/np.sqrt(N+1))*under_w_std
under_w_upper=under_w_avg+(2.0/np.sqrt(N+1))*under_w_std

under_s_avg=100*np.average(under_s,axis=1)
under_s_std=100*np.std(under_s,axis=1)
under_s_lower=under_s_avg-(2.0/np.sqrt(N+1))*under_s_std
under_s_upper=under_s_avg+(2.0/np.sqrt(N+1))*under_s_std

under_r_avg=100*np.average(under_r,axis=1)
under_r_std=100*np.std(under_r,axis=1)
under_r_lower=under_r_avg-(2.0/np.sqrt(N+1))*under_r_std
under_r_upper=under_r_avg+(2.0/np.sqrt(N+1))*under_r_std


axs[0, 0].plot(time_axis,cost_avg, '-', color='orange')
axs[0, 0].fill_between(time_axis,cost_lower,cost_upper,color='orange', alpha=0.2)
axs[0, 0].set_title('Capital cost')

axs[0, 1].plot(time_axis,cost_env_avg, '-', color='orange')
axs[0, 1].fill_between(time_axis,cost_env_lower,cost_env_upper,color='orange', alpha=0.2)
axs[0, 1].set_title('Global Warming Potential')

axs[0, 2].plot(time_axis_full,length_avg, '-', color='orange')
axs[0, 2].fill_between(time_axis_full,length_lower,length_upper,color='orange', alpha=0.2)
axs[0, 2].set_title('Excavated volume')

axs[1, 0].plot(time_axis_full,W_dig_avg, '-', color='orange')
axs[1, 0].fill_between(time_axis_full,W_dig_lower,W_dig_upper,color='orange', alpha=0.2)
axs[1, 0].set_title('Renewal rate water - open cut')

axs[2, 0].plot(time_axis_full,W_no_dig_avg, '-', color='orange')
axs[2, 0].fill_between(time_axis_full,W_no_dig_lower,W_no_dig_upper,color='orange', alpha=0.2)
axs[2, 0].set_title('Renewal rate water - trenchless')

axs[1, 1].plot(time_axis_full,S_dig_avg, '-', color='orange')
axs[1, 1].fill_between(time_axis_full,S_dig_lower,S_dig_upper,color='orange', alpha=0.2)
axs[1, 1].set_title('Renewal rate sewer - open cut')

axs[2, 1].plot(time_axis_full,S_no_dig_avg, '-', color='orange')
axs[2, 1].fill_between(time_axis_full,S_no_dig_lower,S_no_dig_upper,color='orange', alpha=0.2)
axs[2, 1].set_title('Renewal rate sewer - trenchless')

axs[1, 2].plot(time_axis_full,R_coord_avg, '-', color='orange')
axs[1, 2].fill_between(time_axis_full,R_coord_lower,R_coord_upper,color='orange', alpha=0.2)
axs[1, 2].set_title('Renewal rate road - coordinated')

axs[2, 2].plot(time_axis_full,R_avg, '-', color='orange')
axs[2, 2].fill_between(time_axis_full,R_lower,R_upper,color='orange', alpha=0.2)
axs[2, 2].set_title('Renewal rate road - alone')

axs[3, 0].plot(time_axis_full,under_w_avg, '-', color='orange')
axs[3, 0].fill_between(time_axis_full,under_w_lower,under_w_upper,color='orange', alpha=0.2)
axs[3, 0].set_title('Mean underutilization ratio - water')

axs[3, 1].plot(time_axis_full,under_s_avg, '-', color='orange')
axs[3, 1].fill_between(time_axis_full,under_s_lower,under_s_upper,color='orange', alpha=0.2)
axs[3, 1].set_title('Mean underutilization ratio - sewer')

axs[3, 2].plot(time_axis_full,under_r_avg, '-', color='orange')
axs[3, 2].fill_between(time_axis_full,under_r_lower,under_r_upper,color='orange', alpha=0.2)
axs[3, 2].set_title('Mean underutilization ratio - road')

#Simulation, Luleå, Tau=100 years

rho=[[1,0.5,0.5],[0.5,1,0.5],[0.5,0.5,1]]
rho_t=0
sim_start=2020
sim_end=2170
tau=100

N=30
seed=93

cost,cost_env,length,age,under,W_dig,W_no_dig,S_dig,S_no_dig,R,R_coord,under_w,under_s,under_r=murm(rho,rho_t,sim_start,sim_end,tau,seed)


for i in range(N):
    print(i)
    seed=seed+1
    new_cost, new_cost_env, new_length, new_age, new_under, new_W_dig, new_W_no_dig, new_S_dig, new_S_no_dig, new_R, new_R_coord, new_under_w, new_under_s, new_under_r=murm(rho,rho_t,sim_start,sim_end,tau,seed)
    cost=np.column_stack((cost,new_cost))
    cost_env=np.column_stack((cost_env,new_cost_env))
    length=np.column_stack((length,new_length))
    age=np.dstack((age,new_age))
    under=np.dstack((under,new_under))
    W_dig=np.column_stack((W_dig,new_W_dig))
    W_no_dig=np.column_stack((W_no_dig,new_W_no_dig))
    S_dig=np.column_stack((S_dig,new_S_dig))
    S_no_dig=np.column_stack((S_no_dig,new_S_no_dig))
    R=np.column_stack((R,new_R))
    R_coord=np.column_stack((R_coord,new_R_coord))
    under_w=np.column_stack((under_w,new_under_w))
    under_s=np.column_stack((under_s,new_under_s))
    under_r=np.column_stack((under_r,new_under_r))


cost_avg=0.0000001*np.average(cost,axis=1)
cost_std=0.0000001*np.std(cost,axis=1)
cost_lower=cost_avg-(2.0/np.sqrt(N+1))*cost_std
cost_upper=cost_avg+(2.0/np.sqrt(N+1))*cost_std

cost_env_avg=0.001*np.average(cost_env,axis=1)
cost_env_std=0.001*np.std(cost_env,axis=1)
cost_env_lower=cost_env_avg-(2.0/np.sqrt(N+1))*cost_env_std
cost_env_upper=cost_env_avg+(2.0/np.sqrt(N+1))*cost_env_std

length_avg=np.average(length,axis=1)
length_std=np.std(length,axis=1)
length_lower=length_avg-(2.0/np.sqrt(N+1))*length_std
length_upper=length_avg+(2.0/np.sqrt(N+1))*length_std


age_avg=np.average(age,axis=2)
age_std=np.std(age,axis=2)
age_lower=age_avg-(2.0/np.sqrt(N+1))*age_std
age_upper=age_avg+(2.0/np.sqrt(N+1))*age_std

under_avg=0.001*np.average(under,axis=2)
under_std=0.001*np.std(under,axis=2)
under_lower=under_avg-(2.0/np.sqrt(N+1))*under_std
under_upper=under_avg+(2.0/np.sqrt(N+1))*under_std

W_dig_avg=100*np.average(W_dig,axis=1)
W_dig_std=100*np.std(W_dig,axis=1)
W_dig_lower=W_dig_avg-(2.0/np.sqrt(N+1))*W_dig_std
W_dig_upper=W_dig_avg+(2.0/np.sqrt(N+1))*W_dig_std

W_no_dig_avg=100*np.average(W_no_dig,axis=1)
W_no_dig_std=100*np.std(W_no_dig,axis=1)
W_no_dig_lower=W_no_dig_avg-(2.0/np.sqrt(N+1))*W_no_dig_std
W_no_dig_upper=W_no_dig_avg+(2.0/np.sqrt(N+1))*W_no_dig_std

S_dig_avg=100*np.average(S_dig,axis=1)
S_dig_std=100*np.std(S_dig,axis=1)
S_dig_lower=S_dig_avg-(2.0/np.sqrt(N+1))*S_dig_std
S_dig_upper=S_dig_avg+(2.0/np.sqrt(N+1))*S_dig_std

S_no_dig_avg=100*np.average(S_no_dig,axis=1)
S_no_dig_std=100*np.std(S_no_dig,axis=1)
S_no_dig_lower=S_no_dig_avg-(2.0/np.sqrt(N+1))*S_no_dig_std
S_no_dig_upper=S_no_dig_avg+(2.0/np.sqrt(N+1))*S_no_dig_std

R_avg=100*np.average(R,axis=1)
R_std=100*np.std(R,axis=1)
R_lower=R_avg-(2.0/np.sqrt(N+1))*R_std
R_upper=R_avg+(2.0/np.sqrt(N+1))*R_std

R_coord_avg=100*np.average(R_coord,axis=1)
R_coord_std=100*np.std(R_coord,axis=1)
R_coord_lower=R_coord_avg-(2.0/np.sqrt(N+1))*R_coord_std
R_coord_upper=R_coord_avg+(2.0/np.sqrt(N+1))*R_coord_std

under_w_avg=100*np.average(under_w,axis=1)
under_w_std=100*np.std(under_w,axis=1)
under_w_lower=under_w_avg-(2.0/np.sqrt(N+1))*under_w_std
under_w_upper=under_w_avg+(2.0/np.sqrt(N+1))*under_w_std

under_s_avg=100*np.average(under_s,axis=1)
under_s_std=100*np.std(under_s,axis=1)
under_s_lower=under_s_avg-(2.0/np.sqrt(N+1))*under_s_std
under_s_upper=under_s_avg+(2.0/np.sqrt(N+1))*under_s_std

under_r_avg=100*np.average(under_r,axis=1)
under_r_std=100*np.std(under_r,axis=1)
under_r_lower=under_r_avg-(2.0/np.sqrt(N+1))*under_r_std
under_r_upper=under_r_avg+(2.0/np.sqrt(N+1))*under_r_std


axs[0, 0].plot(time_axis,cost_avg, '-', color='green')
axs[0, 0].fill_between(time_axis,cost_lower,cost_upper,color='green', alpha=0.2)
axs[0, 0].set_title('Capital cost')

axs[0, 1].plot(time_axis,cost_env_avg, '-', color='green')
axs[0, 1].fill_between(time_axis,cost_env_lower,cost_env_upper,color='green', alpha=0.2)
axs[0, 1].set_title('Global Warming Potential')

axs[0, 2].plot(time_axis_full,length_avg, '-', color='green')
axs[0, 2].fill_between(time_axis_full,length_lower,length_upper,color='green', alpha=0.2)
axs[0, 2].set_title('Excavated volume')

axs[1, 0].plot(time_axis_full,W_dig_avg, '-', color='green')
axs[1, 0].fill_between(time_axis_full,W_dig_lower,W_dig_upper,color='green', alpha=0.2)
axs[1, 0].set_title('Renewal rate water - open cut')

axs[2, 0].plot(time_axis_full,W_no_dig_avg, '-', color='green')
axs[2, 0].fill_between(time_axis_full,W_no_dig_lower,W_no_dig_upper,color='green', alpha=0.2)
axs[2, 0].set_title('Renewal rate water - trenchless')

axs[1, 1].plot(time_axis_full,S_dig_avg, '-', color='green')
axs[1, 1].fill_between(time_axis_full,S_dig_lower,S_dig_upper,color='green', alpha=0.2)
axs[1, 1].set_title('Renewal rate sewer - open cut')

axs[2, 1].plot(time_axis_full,S_no_dig_avg, '-', color='green')
axs[2, 1].fill_between(time_axis_full,S_no_dig_lower,S_no_dig_upper,color='green', alpha=0.2)
axs[2, 1].set_title('Renewal rate sewer - trenchless')

axs[1, 2].plot(time_axis_full,R_coord_avg, '-', color='green')
axs[1, 2].fill_between(time_axis_full,R_coord_lower,R_coord_upper,color='green', alpha=0.2)
axs[1, 2].set_title('Renewal rate road - coordinated')

axs[2, 2].plot(time_axis_full,R_avg, '-', color='green')
axs[2, 2].fill_between(time_axis_full,R_lower,R_upper,color='green', alpha=0.2)
axs[2, 2].set_title('Renewal rate road - alone')

axs[3, 0].plot(time_axis_full,under_w_avg, '-', color='green')
axs[3, 0].fill_between(time_axis_full,under_w_lower,under_w_upper,color='green', alpha=0.2)
axs[3, 0].set_title('Mean underutilization ratio - water')

axs[3, 1].plot(time_axis_full,under_s_avg, '-', color='green')
axs[3, 1].fill_between(time_axis_full,under_s_lower,under_s_upper,color='green', alpha=0.2)
axs[3, 1].set_title('Mean underutilization ratio - sewer')

axs[3, 2].plot(time_axis_full,under_r_avg, '-', color='green')
axs[3, 2].fill_between(time_axis_full,under_r_lower,under_r_upper,color='green', alpha=0.2)
axs[3, 2].set_title('Mean underutilization ratio - road')


